static char *cesleep_id = 
	"@(#)Copyright (C) H.Shirouzu 2003-2006   cesleep.cpp	Ver1.01";
/* ========================================================================
	Project  Name			: WinCE Sleeper
	Module Name				: Main Module
	Create					: 2003-03-15(Sat)
	Update					: 2006-01-02(Tue)
	Copyright				: H.Shirouzu
	Reference				: 
	======================================================================== */

#include "stdafx.h"
#include "cesleep.h"
#include <commctrl.h>
#include <shellapi.h>
#include <Winnls.h>
#include <uniqueid.h>

//BOOL KernelIoControl(DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned);
#define IOCTL_HAL_REBOOT CTL_CODE(FILE_DEVICE_HAL, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)

#undef WINCEOEM
#include <notify.h>

const WCHAR	*CESLEEP_STR = L"CeSleep";
const WCHAR *SCHEON_STR = L"0:00";
const WCHAR *SCHEDULE_STR = L"CeSleepSchedule";
const int	SCHEDULE_STR_LEN = ::wcslen(SCHEDULE_STR);
const WCHAR *LOGFILE_STR = L"\\CeSleep.txt";

// WinCE  resource ɕ̌ĂAIȂ
// iID̎Ⴂ̂Ilqj߁Aɏ

// {
const WCHAR *SUSPENDDONE_J_STR = L"TXyh";
const WCHAR *CONTPOW_J_STR = L"%dA";
const WCHAR *SUSPEND_J_STR = L"%s ̓dIo܂B\r\n%dbɃTXyhɓ܂B";
const WCHAR *PATHERR_J_STR = L"st@CpXł܂";
const WCHAR *WATCH_J_STR = L"풓ĎJn܂B\r\nɂ -z t\r\nNIĂ";
const WCHAR *IGNOREZ_J_STR = L"-s/-p IvVw肵ꍇA\r\n-z ͖܂";
const WCHAR *DELEVENT_J_STR = L"dIĎ܂";


// p
const WCHAR *SUSPENDDONE_E_STR = L"Suspend done.";
const WCHAR *CONTPOW_E_STR = L"%d min running";
const WCHAR *SUSPEND_E_STR = L"Power on was detected for %s.\r\nAfter %d sec, it will be suspended.";
const WCHAR *PATHERR_E_STR = L"Can't detect executable path.";
const WCHAR *WATCH_E_STR = L"Start to watch power-on event.\r\nIf you want to cancel to watch,\r\nexecute without -z option and exit.";
const WCHAR *IGNOREZ_E_STR = L"If -s/-p option is specified,\r\n-z is ignored.";
const WCHAR *DELEVENT_E_STR = L"Remove to monitor for power-on event";

const WCHAR *SUSPENDDONE_STR = SUSPENDDONE_J_STR;
const WCHAR *CONTPOW_STR = CONTPOW_J_STR;
const WCHAR *SUSPEND_STR = SUSPEND_J_STR;
const WCHAR *PATHERR_STR = PATHERR_J_STR;
const WCHAR *WATCH_STR = WATCH_J_STR;
const WCHAR *IGNOREZ_STR = IGNOREZ_J_STR;
const WCHAR *DELEVENT_STR = DELEVENT_J_STR;

// Global data
struct GlobalData {
	HINSTANCE		hI;
	HWND			hMainWnd;
	HWND			hAboutDlg;
	HWND			hSuspendDlg;

	const WCHAR		*suspendStr;
	int				suspendCnt;
	int				timerMin;
	UINT			timerID;
	HANDLE			hNotify;
	NOTIFYICONDATA	nid;

	UINT			options;
	UINT			status;
} Glb;

/* ========================================================================
	^C}[R[obN
 ======================================================================== */
void CALLBACK TimerProc(HWND hWnd, UINT, UINT id, DWORD)
{
	if (!Glb.hSuspendDlg) {
		static WCHAR	title[16];
		wsprintf(title, CONTPOW_STR, Glb.timerMin);
		::CreateDialogParam(Glb.hI, (LPCTSTR)SUSPEND_DIALOG, NULL, (DLGPROC)SuspendProc, (LPARAM)title);
	}
}

/* ========================================================================
	Oo
 ======================================================================== */
void WriteLog(char *append_str)
{
	if (Glb.options & OPT_NO_LOG)
		return;

	HANDLE	hFile = ::CreateFile(LOGFILE_STR, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile == INVALID_HANDLE_VALUE)
		return;

	SYSTEMTIME	st;
	::GetLocalTime(&st);

	char	buf[128];
	DWORD	len = sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d%s\r\n", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, append_str ? append_str : "");

	::SetFilePointer(hFile, 0, 0, FILE_END);
	::WriteFile(hFile, buf, len, &len, 0);
	::CloseHandle(hFile);
}

/* ========================================================================
	NĎ
 ======================================================================== */
BOOL CheckWakeup(void)
{
// ANp^C}[Zbgi-s w莞j
	if (Glb.timerMin) {
		if (Glb.timerID)
			::KillTimer(0, Glb.timerID);
		Glb.timerID = ::SetTimer(0, 0, Glb.timerMin * 60 * 1000, TimerProc);
	}

// OL^
	WriteLog();

	SYSTEMTIME	st;
	::GetLocalTime(&st);

// ߑO 0:00-0:01 ̋N`FbN
//		static int test;
//		if (Glb.status & ST_POWER_ON_EVENT) && (GetTickCount() % 2) || (++test % 3) == 0 && Glb.hSuspendDlg == NULL) // for test
	if (st.wHour == 0 && st.wMinute <= 1 && Glb.hSuspendDlg == NULL) {
		if (!Glb.hMainWnd) {
			InitStrings();
			InitMainWindow();
		}
		::CreateDialogParam(Glb.hI, (LPCTSTR)SUSPEND_DIALOG, NULL, (DLGPROC)SuspendProc, (LPARAM)SCHEON_STR);
		return	TRUE;
	}
	return	FALSE;
}

/* ========================================================================
	Cxgf[^x[XT
 ======================================================================== */
BOOL FindEventDB(CEGUID *guid, CEOID *oid)
{
	WCHAR		buf[MAX_BUF];
	CEOIDINFO	info;
	HANDLE		hFind;
	BOOL		found = FALSE;

	CREATE_INVALIDGUID(guid);

	while (!found && ::CeEnumDBVolumes(guid, buf, MAX_BUF)) {
		if ((hFind = ::CeFindFirstDatabaseEx(guid, 0)) == INVALID_HANDLE_VALUE)
			continue;
		while ((*oid = ::CeFindNextDatabaseEx(hFind, guid))) {
			if (!::CeOidGetInfoEx(guid, *oid, &info) || info.wObjType != OBJTYPE_DATABASE)
				continue;
			if (wcscmp(info.infDatabase.szDbaseName, EVENT_DB) == 0) {
				found = TRUE;
				break;
			}
		}
		::CloseHandle(hFind);
	}
	return	found;
}

/* ========================================================================
	XPW[폜idICxgj
 ======================================================================== */
BOOL DeletePowerOnEvent(void)
{
	CEGUID		guid;
	CEOID		oid;
	CEPROPVAL	*props = NULL;
	WORD		num;
	DWORD		size;
	BOOL		deleted = FALSE;
	HANDLE		hDB;

	if (!FindEventDB(&guid, &oid))
		return	::MessageBox(0, L"Can't find EventDB", NULL, MB_OK), FALSE;

	if ((hDB = ::CeOpenDatabaseEx(&guid, &oid, EVENT_DB, 0, CEDB_AUTOINCREMENT, NULL)) == INVALID_HANDLE_VALUE)
		return	::MessageBox(0, L"Can't open EventDB", NULL, MB_OK), FALSE;

	while ((oid = ::CeReadRecordPropsEx(hDB, CEDB_ALLOWREALLOC, &num, 0, (LPBYTE*)&props, &size, 0))) {
		for (int i=0; i < num; i++) {
			if (props[i].propid == PROP_TAG(CEVT_LPWSTR, 2)) {
				if (wcsncmp(props[i].val.lpwstr, SCHEDULE_STR, SCHEDULE_STR_LEN) == 0) {
					::CeDeleteRecord(hDB, oid);
					deleted = TRUE;
				}
				break;
			}
		}
		::LocalFree(props);
	}
	::CloseHandle(hDB);

	if (deleted)
		::CeFlushDBVol(&guid);

	return	TRUE;
}

/* ========================================================================
	XPW[o^idICxgj
 ======================================================================== */
BOOL RegisterPowerOnEvent(void)
{
// łɉߋɓo^XPW[T
	DeletePowerOnEvent();

// st@C̎擾
	WCHAR	path[MAX_PATH], arg[MAX_PATH];

	if (::GetModuleFileName(NULL, path, MAX_PATH) == 0)
		return	::MessageBox(0, PATHERR_STR, NULL, MB_OK), FALSE;

// CxgXPW[ɓo^
	CE_NOTIFICATION_TRIGGER nt;
	::ZeroMemory(&nt, sizeof(nt));
	nt.dwSize = sizeof(nt);
	nt.dwType = CNT_EVENT;
	nt.dwEvent = NOTIFICATION_EVENT_WAKEUP;
	nt.lpszApplication = path;
	::wcscpy(arg, SCHEDULE_STR);
	if (Glb.options & OPT_NO_LOG)		::wcscat(arg, L" -n");
	if (Glb.options & OPT_POWER_OFF)	::wcscat(arg, L" -p");
	if (Glb.options & OPT_NO_RESULTMSG)	::wcscat(arg, L" -r");
	if (Glb.options & OPT_NO_DAEMON)	::wcscat(arg, L" -z");
	nt.lpszArguments = arg;

	if (!(Glb.hNotify = ::CeSetUserNotificationEx(NULL, &nt, NULL)))
		return	MessageBox(0, L"CeSetUserNotificationEx", NULL, MB_OK), FALSE;
	return	TRUE;
}

/* ========================================================================
	bZ[W̏
 ======================================================================== */
void InitStrings(void)
{
	if ((GetUserDefaultLangID() & 0x3ff) != LANG_JAPANESE) {
		SUSPENDDONE_STR = SUSPENDDONE_E_STR;
		CONTPOW_STR = CONTPOW_E_STR;
		SUSPEND_STR = SUSPEND_E_STR;
		PATHERR_STR = PATHERR_E_STR;
		WATCH_STR = WATCH_E_STR;
		IGNOREZ_STR = IGNOREZ_E_STR;
		DELEVENT_STR = DELEVENT_J_STR;
	}
}

/* ========================================================================
	BꃁCEBhE쐬
 ======================================================================== */
BOOL InitMainWindow(void)
{
// EBhENXo^
	WNDCLASS	wc;
	::ZeroMemory(&wc, sizeof(wc));
    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.hInstance		= Glb.hI;
    wc.hIcon			= ::LoadIcon(Glb.hI, MAKEINTRESOURCE(IDI_CEICON));
    wc.lpszClassName	= CESLEEP_STR;

	if (!::RegisterClass(&wc))
		return	FALSE;

// CEBhE쐬
	if ((Glb.hMainWnd = ::CreateWindow(CESLEEP_STR, CESLEEP_STR, 0, 0, 0, 0, 0, 0, NULL, Glb.hI, 0)) == NULL)
		return	FALSE;
//	::ShowWindow(Glb.hMainWnd, SW_HIDE);
	return	TRUE;
}

/* ========================================================================
	I[`
 ======================================================================== */
void Terminate()
{
	::CeClearUserNotification(Glb.hNotify);
	if ((Glb.options & OPT_NO_DAEMON) == 0)
		DeletePowerOnEvent();
	::Shell_NotifyIcon(NIM_DELETE, &Glb.nid);
}

BOOL RebootDevice()
{
	DWORD ret = 0;
	return	::KernelIoControl(IOCTL_HAL_REBOOT, 0, 0, 0, 0, &ret);
}

/* ========================================================================
	AoEg_CAOpR[obN
 ======================================================================== */
LRESULT CALLBACK AboutProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		::SetWindowPos(Glb.hAboutDlg = hDlg, HWND_TOP, ::GetSystemMetrics(SM_CXSCREEN) >= 600 ? 200 : 0, 50, 0, 0, SWP_NOSIZE|SWP_SHOWWINDOW);
		::SetForegroundWindow(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK: case IDCANCEL: case IDEND:
			::EndDialog(hDlg, LOWORD(wParam));
			break;

		case REBOOT_BUTTON:
			if (::MessageBox(hDlg, L"Reboot this device?", L"CeSleep", MB_OKCANCEL) == IDOK) {
				RebootDevice();
			}
			::EndDialog(hDlg, LOWORD(wParam));
			break;
		}
		break;

	case WM_DESTROY:
		Glb.hAboutDlg = NULL;
		break;
	}
    return 0;
}

/* ========================================================================
	_CAOACeݒ
 ======================================================================== */
void SetSuspendStr(HWND hWnd, int cnt)
{
	WCHAR	wbuf[128];
	::wsprintf(wbuf, SUSPEND_STR, Glb.suspendStr, cnt);
	::SetDlgItemText(hWnd, NOTIFY_STATIC, wbuf);
}

/* ========================================================================
	TXyh_CAOpR[obN
 ======================================================================== */
LRESULT CALLBACK SuspendProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		Glb.suspendStr = (const WCHAR *)lParam;
		SetSuspendStr(hDlg, Glb.suspendCnt = SUSPEND_LIMIT);
		::SetWindowPos(Glb.hSuspendDlg = hDlg, HWND_TOP, ::GetSystemMetrics(SM_CXSCREEN) >= 600 ? 200 : 0, 50, 0, 0, SWP_NOSIZE|SWP_SHOWWINDOW);
		::SetForegroundWindow(hDlg);
		::SetTimer(hDlg, TIMERID, DEFAULT_TIMER, NULL);
		return TRUE;

	case WM_TIMER:
		if (--Glb.suspendCnt >= 0) {
			SetSuspendStr(hDlg, Glb.suspendCnt);
			break;
		}
		::KillTimer(hDlg, TIMERID);
		::DestroyWindow(hDlg);
		::PostMessage(Glb.hMainWnd, WM_SUSPEND, 0, 0);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			::KillTimer(hDlg, TIMERID);
			::DestroyWindow(hDlg);
			if (Glb.status & ST_POWER_ON_EVENT)
				::PostQuitMessage(0);
			break;
		}
		break;

	case WM_DESTROY:
		Glb.hSuspendDlg = NULL;
		break;
	}
    return 0;
}

/* ========================================================================
	Power OFF
 ======================================================================== */
void PowerOff(char *opt)
{
	char	append[64];

	sprintf(append, "%s(%s)", " - PowerOff by CeSleep", opt);
	WriteLog(append);
	::keybd_event(VK_OFF, 0, KEYEVENTF_SILENT, 0);
	::keybd_event(VK_OFF, 0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT, 0);
}

/* ========================================================================
	CEBhEpR[obN
 ======================================================================== */
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_COMMAND: case WM_CREATE:
		break;

	case WM_TRAY_NOTIFY:
		if (lParam == WM_LBUTTONUP) {
			if ((Glb.options & OPT_POWER_OFF) && (::GetAsyncKeyState(VK_CONTROL) & 0x8000) == 0) {
				PowerOff("p");
			}
			else if (Glb.hAboutDlg) {
				::SetForegroundWindow(Glb.hAboutDlg);
				::ShowWindow(Glb.hAboutDlg, SW_SHOWNORMAL);
			}
			else if (::DialogBox(Glb.hI, (LPCTSTR)ABOUT_DIALOG, 0, (DLGPROC)AboutProc) == IDEND)
				::PostQuitMessage(0);
		}
		break;

	case WM_POWER_NOTIFY:
		if (Glb.hSuspendDlg)
			::DestroyWindow(Glb.hSuspendDlg);
		CheckWakeup();
		break;

	case WM_DUPEXEC_NOTIFY:
		if (Glb.options & OPT_POWER_OFF)
			::PostQuitMessage(0);
		break;

	case WM_SUSPEND:
		PowerOff(Glb.suspendStr == SCHEON_STR ? "0" : "s");
		if ((Glb.options & OPT_NO_RESULTMSG) == 0)
			::MessageBox(0, SUSPENDDONE_STR, CESLEEP_STR, MB_OK|MB_SETFOREGROUND|MB_ICONINFORMATION);
		if (Glb.status & ST_POWER_ON_EVENT)
			::PostQuitMessage(0);
		break;

	default:
		return ::DefWindowProc(hWnd, uMsg, wParam, lParam);
   }
   return 0;
}

/* ========================================================================
	[`
 ======================================================================== */
BOOL Initialize(HINSTANCE hI, LPTSTR cmdLine)
{
	Glb.hI = hI;

// łɋNς݂Hiiȃ`FbNł͂ȂB蔲Bǂq͐^ȂƁj
// ɁA SCHEDULE_STR ̏ꍇAXPW[̋NƂ݂ȂB
	HWND	hWnd = ::FindWindow(CESLEEP_STR, NULL);

// dON Cxg
	if (::wcsncmp(SCHEDULE_STR, cmdLine, SCHEDULE_STR_LEN) == 0) {
		Glb.status |= ST_POWER_ON_EVENT;
		cmdLine += SCHEDULE_STR_LEN;
	}

	for (WCHAR *tok = ::wcstok(cmdLine, L" \t"); tok && tok[0] == '-'; tok = ::wcstok(NULL, L" \t")) {
		switch (tok[1]) {
		case 'e':
			if (hWnd == NULL) {
				DeletePowerOnEvent();
				if (tok[2] != 'e')
					::MessageBox(0, DELEVENT_STR, CESLEEP_STR, MB_OK);
			}
			return	FALSE;

		case 'n':
			Glb.options |= OPT_NO_LOG;
			break;

		case 'p':
			Glb.options |= OPT_POWER_OFF;
			break;

		case 'r':
			Glb.options |= OPT_NO_RESULTMSG;
			break;

		case 'R':
			RebootDevice();
			break;

		case 's':
			if ((Glb.timerMin = wcstoul(tok + 2, 0, 0)) == 0)
				Glb.timerMin = IDLE_LIMIT;
			break;

		case 'x':
			PowerOff("x");
			return	FALSE;

		case 'z':
			Glb.options |= OPT_NO_DAEMON;
			if (tok[2] == 'z')
				Glb.options |= OPT_NO_DAEMONMSG;
			break;
		}
	}

	if (Glb.status & ST_POWER_ON_EVENT) {
		if (hWnd)
			::PostMessage(hWnd, WM_POWER_NOTIFY, 0, 0);
		else if (CheckWakeup())
			return	TRUE;
		return	FALSE;
	}

// dN
	if (hWnd) {
		::PostMessage(hWnd, WM_DUPEXEC_NOTIFY, 0, 0);
		return	FALSE;
	}

// bZ[W񏉊
	InitStrings();

// dICxgXPW[ɓo^
	if (!RegisterPowerOnEvent())
		return	FALSE;

// 풓Ȃi-zj
	if (Glb.options & OPT_NO_DAEMON) {
		if (!(Glb.options & OPT_POWER_OFF) && Glb.timerMin == 0) {
			if ((Glb.options & OPT_NO_DAEMONMSG) == 0) {
				::MessageBox(0, WATCH_STR, CESLEEP_STR, MB_OK);
			}
			return	FALSE;
		}
		Glb.options &= ~OPT_NO_DAEMON;
		::MessageBox(0, IGNOREZ_STR, CESLEEP_STR, MB_OK);
	}

// CEBhE쐬
	if (!InitMainWindow())
		return	FALSE;

// ^XNgCo^
	::ZeroMemory(&Glb.nid, sizeof(NOTIFYICONDATA));
	Glb.nid.cbSize = sizeof(NOTIFYICONDATA);
	Glb.nid.hWnd = Glb.hMainWnd;
	Glb.nid.uID = WM_TRAY_NOTIFY;
	Glb.nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	Glb.nid.uCallbackMessage = WM_TRAY_NOTIFY;
	Glb.nid.hIcon = (HICON)::LoadImage(Glb.hI, MAKEINTRESOURCE((Glb.options & OPT_POWER_OFF) ? IDI_POWICON : IDI_CEICON), IMAGE_ICON, 16, 16, 0);

	if (!::Shell_NotifyIcon(NIM_ADD, &Glb.nid))
		return	FALSE;

	CheckWakeup();

	return	TRUE;
}

/* ========================================================================
	WinMain
 ======================================================================== */
int WINAPI WinMain(HINSTANCE hI, HINSTANCE, LPTSTR cmdLine, int)
{
	MSG msg;

	if (!Initialize(hI, cmdLine))
		return	0;

	// Main message loop:
	while (::GetMessage(&msg, NULL, 0, 0)) {
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}

	Terminate();

	return msg.wParam;
}

