/* @(#)Copyright (C) H.Shirouzu 2003-2006   cesleep.h	Ver1.01 */
/* ========================================================================
	Project  Name			: WinCE Sleeper
	Module Name				: Main Module
	Create					: 2003-03-15(Sat)
	Update					: 2007-01-02(Tue)
	Copyright				: H.Shirouzu
	Reference				: 
	======================================================================== */

#include "resource.h"

#define MAX_BUF				1024

#define WM_TRAY_NOTIFY		(WM_USER + 100)
#define WM_POWER_NOTIFY		(WM_USER + 101)
#define WM_POWER_OFF		(WM_USER + 102)
#define WM_DUPEXEC_NOTIFY	(WM_USER + 103)
#define WM_SUSPEND			(WM_USER + 104)

#define TIMERID				100
#define DEFAULT_TIMER		1000
#define SUSPEND_LIMIT		20
#define IDLE_LIMIT			60

#define OPT_NO_LOG			0x0001
#define OPT_NO_DAEMON		0x0002
#define OPT_POWER_OFF		0x0008
#define OPT_NO_RESULTMSG	0x0010
#define OPT_NO_DAEMONMSG	0x0020

#define ST_POWER_ON_EVENT	0x0001

#define EVENT_DB			L"DB_notify_events"
#ifndef PROP_TAG
#define PROP_TAG(ulPropType,ulPropID)  ((((ULONG)(ulPropID))<<16)|((ULONG)(ulPropType)))
#endif

BOOL Initialize(HINSTANCE hI, LPTSTR cmdLine);
void InitStrings(void);
BOOL InitMainWindow(void);
void Terminate(void);

BOOL RegisterPowerOnEvent(void);
BOOL CheckWakeup(void);
void PowerOff(char *opt);
void WriteLog(char *append_str=NULL);
void SetSuspendStr(HWND hWnd, int cnt);

LRESULT CALLBACK AboutProc(HWND _hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK SuspendProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void CALLBACK TimerProc(HWND hWnd, UINT, UINT id, DWORD);

